<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  FeaturedMedia,
  CopyMedia,
  Copy,
} from '../../components/common/index.vue';
import {
  SdlRelatedCard,
  SdlCta,
} from '../../components/stages-devops-lifecycle/index.vue';
import { getPageMetadata } from '~/common/meta';
import FeaturesTemplate from '~/components/features/templates/features-template.vue';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';

export default Vue.extend({
  components: {
    SdlCta,
    SdlRelatedCard,
    Copy,
    CopyMedia,
    FeaturedMedia,
    CallToAction,
    FeaturesTemplate,
  },
  nuxtI18n: false,
  async asyncData({ params }: any) {
    const client = getClient();
    let contentful = await client.getEntries({
      'fields.slug': `/stages-devops-lifecycle/${params.slug}/`,
      content_type: CONTENT_TYPES.PAGE,
      include: 2,
    });
    contentful = contentful.items[0].fields;

    const seo = contentful.seoMetadata[0].fields;

    const hero = contentful.pageContent
      .filter((entry) => entry.sys.contentType.sys.id === CONTENT_TYPES.CARD)
      .map((entry) => entry.fields)[0];

    const card_group = contentful.pageContent
      .filter(
        (entry) => entry.sys.contentType.sys.id === CONTENT_TYPES.CARD_GROUP,
      )
      .map((entry) => entry.fields);

    const doc = {
      components: [
        {
          name: 'sdl-cta',
          data: {
            title: hero.title,
            aos_animation: 'fade-down',
            aos_duration: 500,
            subtitle: hero.subtitle,
            text: hero.description,
            icon: {
              name: hero.iconName,
              alt: '',
              variant: 'marketing',
            },
          },
        },
        {
          name: 'featured-media',
          data: {
            column_size: 6,
            header: card_group[0].header,
            header_animation: 'fade-up',
            header_animation_duration: 500,
            media: card_group[0].card
              .map((data) => data.fields)
              .map((card) => ({
                title: card.title,
                aos_animation: 'fade-up',
                aos_duration: 500,
                shadow_hover: true,
                text: card.description,
                link: {
                  href: card.cardLink,
                  text: 'Learn more',
                  data_ga_name: card.cardLinkDataGaName,
                  data_ga_location: 'body',
                },
              })),
          },
        },
        {
          name: 'copy',
          data: {
            aos_animation: 'fade-up',
            aos_duration: 500,
            block: [
              {
                align_center: true,
                text: card_group[0].description,
              },
            ],
          },
        },
        {
          name: 'sdl-related-card',
          data: {
            column_size: 4,
            header: card_group[1].header,
            cards: card_group[1].card
              .map((data) => data.fields)
              .map((card) => ({
                title: card.title,
                icon: {
                  name: card.iconName,
                  alt: '',
                  variant: 'marketing',
                },
                aos_animation: 500,
                text: card.subtitle,
                link: {
                  text: 'Learn more',
                  href: card.cardLink,
                  data_ga_name: card.cardLinkDataGaName,
                  data_ga_location: 'body',
                },
              })),
          },
        },
      ],
    };

    return { seo, doc };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).seo, this.$route.path);
  },
});
</script>

<template>
  <features-template v-if="doc.template === 'feature'" :page="doc" />
  <SlpContainer v-else>
    <component
      :is="component.name"
      v-for="component in doc.components"
      :key="component.name"
      :data="component.data"
    />
  </SlpContainer>
</template>
